addHook("MobjSpawn", function(mo) mo.recovering = 0 end, MT_PLAYER)

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo then
                        if not (player.pflags & PF_NIGHTSMODE)
                        and (player.cmd.buttons & BT_USE)
			and not (player.pflags & (PF_ROPEHANG|PF_CARRIED|PF_ITEMHANG|PF_MACESPIN))
			and not (player.exiting)
			and (player.mo.state == S_PLAY_PAIN)
			and not (player.mo.state == S_PLAY_DIE)
			and not (player.pflags & PF_SLIDING)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_TIMEOVER)
			and not (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_JUMPDOWN)
			and not (player.pflags & PF_JUMPSTASIS)
			and not (player.mo.state == S_PLAY_ATK1)
			and not (player.mo.state == S_PLAY_ATK2)
			and not (player.mo.state == S_PLAY_ATK3)
			and not (player.mo.state == S_PLAY_ATK4)
			and not (player.weapondelay)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
                        and not P_IsObjectOnGround(player.mo)
			and (player.mo.recovering == 0)
				P_SetObjectMomZ(player.mo, FRACUNIT*10, false)
				player.mo.state = S_PLAY_ATK1
				player.pflags = $1|PF_JUMPED
				S_StartSound(player.mo, sfx_jump)
			player.mo.recovering = 1
                        end
			if player.mo.recovering == 1
			and not (player.cmd.buttons & BT_USE)
			player.mo.recovering = 0
			end
		end
	end
end)